from models.game import Game
from models.order import Order
from requests.connection import get_cursor


def get_wishlist(user_id):
    (cursor, conn) = get_cursor()

    cursor.execute("SET lc_monetary TO 'ru_RU.UTF-8'")

    cursor.execute(f"""
        select *
        from wishlists_games join wishlists using(wishlist_id) join board_games using(board_game_id)
        where client_id = {user_id}
    """)

    res = cursor.fetchall()
    parsed = []

    for game in res:
        parsed.append(Game(game[0], game[3], game[4], game[5], game[6]))

    return parsed


def get_cart(user_id):
    (cursor, conn) = get_cursor()

    cursor.execute("SET lc_monetary TO 'ru_RU.UTF-8'")

    cursor.execute(f"""
        select *
        from bags_board_games join bags using(bag_id) join board_games using(board_game_id)
        where client_id = {user_id}
    """)

    res = cursor.fetchall()
    parsed = []

    for game in res:
        parsed.append(Game(game[0], game[4], game[5], game[6], game[7], game[2]))

    return parsed

def get_history(user_id):
    (cursor, conn) = get_cursor()

    cursor.execute("SET lc_monetary TO 'ru_RU.UTF-8'")

    cursor.execute(f"select * from orders where client_id = {user_id}")

    res = [Order(o[0], o[2], o[3], o[4]) for o in cursor.fetchall()]

    for order in res:
        cursor.execute("SET lc_monetary TO 'ru_RU.UTF-8'")

        cursor.execute(f"""
            select *
            from orders_games join board_games using(board_game_id)
            where order_id = {order.id}
        """)

        games = [Game(g[0], g[4], g[5], g[6], g[7], g[3]) for g in cursor.fetchall()]

        order.games = games

    return res
